#uses "fwSystemOverview/fwSystemOverview.ctl"
#uses "fwSystemOverview/fwSystemOverviewFsm.ctl"
#uses "fwSystemOverview/fwSystemOverviewLongTermReport.ctl"
#uses "fwInstallation/fwInstallationDB.ctl"


mapping fwColorToColor;
const string rss_FOLDER = "/user/unicryo/www/MOON/HtmlFiles/";

void fwSysOverviewXmlTree_dumpFsmTreesToXml(string filePath, string screenshotsFolder)
{
  _fwSysOverviewXmlTree_initColorMapping(); 
  dyn_string soTrees;
  fwSystemOverviewFsm_getTrees(soTrees); 
  for(int i = 1; i<= dynlen(soTrees); i++)
  {
    int docId = xmlNewDocument();
    xmlAppendChild(docId, -1, XML_PROCESSING_INSTRUCTION_NODE, "xml version=\"1.0\" encoding=\"ISO-8859-1\"");  
    xmlAppendChild(docId, -1, XML_PROCESSING_INSTRUCTION_NODE, "xml-stylesheet type=\"text/xsl\" href=\"xmlTree.xsl\""); 
    int topNodeId = xmlAppendChild(docId, -1, XML_ELEMENT_NODE, "tree");
    xmlSetElementAttribute(docId, topNodeId, "time", formatTime("%H:%M %d/%m/%Y", getCurrentTime()));
    int treeID = fwSysOverviewXmlTree_addRoot(docId, topNodeId, soTrees[i], screenshotsFolder);
    dyn_int flags;
    dyn_string applications = fwFsm_getObjChildren(soTrees[i], soTrees[i], flags);  //fwCU_getChildren(types, "fwSO_LHC_Applications");
    fwSysOverviewXmlTree_addChildrenToXml(docId, applications, treeID, soTrees[i], screenshotsFolder, true);

    xmlDocumentToFile(docId, filePath + soTrees[i] +".xml");

    xmlCloseDocument(docId);
  }
}

void _fwSysOverviewXmlTree_initColorMapping()
{
  fwColorToColor["FwStateOKPhysics"] = "green";
  fwColorToColor["unAlarm_Ok"] = "green";  
  fwColorToColor["FwStateAttention3"] = "red";  
  fwColorToColor["FwStateAttention2"] = "orange";    
  fwColorToColor["unAlarm_AnalogHH"] = "orange";      
  fwColorToColor["FwStateAttention1"] = "yellow";  
  fwColorToColor["unAlarmMasked"] = "yellow";  
  fwColorToColor["_3DFace"] = "gray";
}
int fwSysOverviewXmlTree_addRoot(int docId, int nodeId, string tree, string screenshotsFolder)
{       
  string state, color, label;
  fwUi_getCurrentState(tree, tree, state);
  fwUi_getObjStateColor(tree, tree, state, color);
  //DebugN("tree: " + tree + " state: " + state + " color:" +color);
  fwUi_getLabel(tree, tree, label);
  int child = xmlAppendChild(docId, nodeId, XML_ELEMENT_NODE, "branch");
  xmlSetElementAttribute(docId, child, "id", tree);
  xmlSetElementAttribute(docId, child, "du", "0"); // the tree is never device unit
  xmlSetElementAttribute(docId, child, "state", state);
  xmlSetElementAttribute(docId, child, "label", label);
  if(mappingHasKey(fwColorToColor, color))
   xmlSetElementAttribute(docId, child, "color", fwColorToColor[color]); 
  else
  {
       xmlSetElementAttribute(docId, child, "color", "white"); 
       //DebugN("color: 1" + color, label);
  }
  xmlSetElementAttribute(docId, child, "picture", screenshotsFolder + tree + ".png");   
  int subChild = xmlAppendChild(docId, child, XML_ELEMENT_NODE, "branchText");
  xmlAppendChild(docId, subChild, XML_TEXT_NODE, label);
  return child;
}
fwSysOverviewXmlTree_addChildrenToXml(int docId, dyn_string children, int nodeId, string cu, string screenshotsFolder, bool addPicture = false)
{
  dyn_int flags;
  for (int i=1; i<= dynlen(children); i++)
  {
    string node = children[i];
    if (strpos(node, "::") >0)
    {
      dyn_string tmpArr = strsplit(node, "::");
      node = tmpArr[1];
    }
    string du, color, state, label;
    string currentCu;
    if (fwSysOverviewFsm_isDomain(node))
      currentCu = node;
    else
      currentCu = cu;

    dyn_string currentNodeChildren =  fwFsm_getObjChildren(currentCu, node, flags);        

    //if it has children - > branch; 
    string childType = (dynlen(currentNodeChildren) > 0)? "branch":"leaf";
    du = fwFsm_isDU(currentCu, node)?"1":"0";
    
    fwUi_getCurrentState(currentCu, node, state);
    string mode = fwUi_getCUMode(currentCu, node);
	  if ((mode == "Excluded")|| (mode == "LockedOut") || (mode == "LockedOutPerm") || (mode == "ExcludedPerm") || (mode == "DEAD"))
      color = "_3DFace";
    else
      fwUi_getObjStateColor(currentCu, node, state, color);
    
    fwUi_getLabel(currentCu, node, label);
    int child = xmlAppendChild(docId, nodeId, XML_ELEMENT_NODE, childType);
    xmlSetElementAttribute(docId, child, "id", node);
    xmlSetElementAttribute(docId, child, "du", du);
    xmlSetElementAttribute(docId, child, "state", state);
    xmlSetElementAttribute(docId, child, "label", label);
    if(mappingHasKey(fwColorToColor, color))
      xmlSetElementAttribute(docId, child, "color", fwColorToColor[color]); 
    else
    {
      xmlSetElementAttribute(docId, child, "color", "white");       
      //DebugN("color: " + color, label);
    }
    if (addPicture)
      xmlSetElementAttribute(docId, child, "picture", screenshotsFolder + node + ".png"); 
    
    int subChild = xmlAppendChild(docId, child, XML_ELEMENT_NODE, childType + "Text");
    xmlAppendChild(docId, subChild, XML_TEXT_NODE, label);
    if (dynlen(currentNodeChildren) > 0)
    {
      fwSysOverviewXmlTree_addChildrenToXml(docId, currentNodeChildren, child, currentCu, screenshotsFolder);
    }
    else if (du == "1") // if it is device unit
    {
      string dp;
      fwCU_getDevDp(currentCu + "::" + node, dp);
      
      
if(dp == "moon_300:FMC/RADE-01/Monitoring.OS.readings.name")  
{

}  
      
      string dpType = dpTypeName(dp);
      switch(dpType)
      {
        case "IcemonPlc":
          fwSysOverviewXmlTree_addPlcDetails(docId, child, dp);
          break;
        case "IcemonFec":
          fwSysOverviewXmlTree_addFecDetails(docId, child, dp);
          break;  
        case "FwSystemOverviewProject":
          fwSysOverviewXmlTree_addProjectDetails(docId, child, dp);
          break;
        case "FwFMCNode":
          fwSysOverviewXmlTree_addHostDetails(docId, child, dp);          
          break;   
        case "IcemonSystemIntegrity":
          fwSysOverviewXmlTree_addSystemIntegrityDetails(docId, child, dp);
          break;       
        case "IcemonDipMonitoring":
          fwSysOverviewXmlTree_addDipMonitoringDetails(docId, child, dp + ".");
          break;
        case "IcemonDIPRDBMonitoring":
          fwSysOverviewXmlTree_addDipMonitoringDetails(docId, child, dp + ".alarm", dp + ".alarm");
          break;
        case "IcemonDIPDNSMonitoring":
          fwSysOverviewXmlTree_addDipDnsMonitoringDetails(docId, child, dp);
          break;
        case "IcemonLicenseGenerator":
          fwSysOverviewXmlTree_addLicenseGeneratorDetails(docId, child, dp);
          break;  
      }
      
    }
  }
}



void fwSysOverviewXmlTree_addProjectDetails(int docId, int nodeId, string projectDp)
{
  if (dpTypeName(projectDp) != "FwSystemOverviewProject")
  {
    DebugN("Not an FwSystemOverviewProject: " + projectDp);
    return;
  }
  // get system information

  string systemName;
  dpGet(projectDp + fwSysOverview_PROJECT_SYSTEM, systemName);
  dyn_mixed systemInfo;
  fwInstallationDB_connect();
  fwInstallationDB_getPvssSystemProperties(systemName, systemInfo);
  dyn_mixed projectInfo;
  string hostDp;
  string host = "";
  dyn_string exceptionInfo;
  string project = "";
  fwSysOverview_getProjectPc(projectDp, hostDp, exceptionInfo);
  if(dynlen(exceptionInfo))
  {
     DebugN("ERROR: lib fwSystemOverview/fwSystemOverviewXmlTree.ctl, function fwSysOverviewXmlTree_addProjectDetails(), MSG: ", exceptionInfo);
  }
  
  fwSysOverview_getHostDb(hostDp, host, exceptionInfo);
  if(dynlen(exceptionInfo))
  {
     DebugN("ERROR: lib fwSystemOverview/fwSystemOverviewXmlTree.ctl, function fwSysOverviewXmlTree_addProjectDetails(), MSG: ", exceptionInfo);
  }

  fwSysOverview_getProjectDb(projectDp, project, exceptionInfo);
  if(dynlen(exceptionInfo))
  {
     DebugN("ERROR: lib fwSystemOverview/fwSystemOverviewXmlTree.ctl, function fwSysOverviewXmlTree_addProjectDetails(), MSG: ", exceptionInfo);
  }

  
  int projectId;
  fwInstallationDB_getProjectProperties(project, host, projectInfo, projectId);
  // add attributes for the system information
  int child = xmlAppendChild(docId, nodeId, XML_ELEMENT_NODE, "project");

  xmlSetElementAttribute(docId, child, "panel", "scada://" + project + "/vision/graphicalFrame/unicosHMI.pnl");

  if(dynlen(projectInfo) >= FW_INSTALLATION_DB_PROJECT_RESPONSIBLE)
  {  
    xmlSetElementAttribute(docId, child, "responsible", projectInfo[FW_INSTALLATION_DB_PROJECT_RESPONSIBLE]);     
  }
  
  if (dynlen(systemInfo) > 0)
  {
    fwSysOverviewXmlTree_addInfoNode(docId, child, "System Host", systemInfo[FW_INSTALLATION_DB_SYSTEM_COMPUTER]);     
    fwSysOverviewXmlTree_addInfoNode(docId, child, "System Name", systemInfo[FW_INSTALLATION_DB_SYSTEM_NAME]);   
    fwSysOverviewXmlTree_addInfoNode(docId, child, "System Number", systemInfo[FW_INSTALLATION_DB_SYSTEM_NUMBER]);   
  }
  //add description and state for the managers
  dyn_string managersDps = dpNames(projectDp + "/Manager*", "FwSystemOverviewManager");
  dyn_string managersTypeDpes, managersOptionsDpes, managersStateDpes;
  int numberOfManagers = dynlen(managersDps);
  for (int i=1; i <= numberOfManagers; i++)
  {
    managersTypeDpes[i] = managersDps[i] + fwSysOverview_MANAGER_TYPE;
    managersOptionsDpes[i] = managersDps[i] + fwSysOverview_MANAGER_OPTIONS;
    managersStateDpes[i] = managersDps[i] + fwSysOverview_MANAGER_STATE;    
  } 
  dyn_int managersStates;
  dyn_string managersTypes, managersOptions;
  if(numberOfManagers > 0)
  {
    dpGet(managersTypeDpes, managersTypes, managersStateDpes, managersStates, managersOptionsDpes,managersOptions);
  }  
  for (int i=1; i <= numberOfManagers; i++)
  {
    string color;
    if (dynlen(managersStates) == 0)
    {
      DebugN("projectDp:" + projectDp);
      break;
    }
    switch(managersStates[i])
    {
      case 10:
        color = "red"; // abnormaly stopped
        break;
      case 0:
        color = "white"; // not running - normal
        break;
      case 2:
        color = "green"; // running
        break;
      case 3:
        color = "purple"; // blocked
        break;
    }
    int authPos = strpos(managersOptions[i], "-author");
    if (authPos >= 0)
    {
      string tmp = substr(managersOptions[i], 0, strlen(managersOptions[i]) - authPos);
      managersOptions[i] = tmp;
    }
    fwSysOverviewXmlTree_addDataNode(docId, child,  managersTypes[i] + " " + managersOptions[i], color);
  } 
}

void fwSysOverviewXmlTree_addHostDetails(int docId, int nodeId, string hostDp)
{
  if (dpTypeName(hostDp) != "FwFMCNode")
  {
    DebugN("Not an FwFMCNode: " + hostDp);
    return;
  }
  // get host information
  //get cpu and cpuspeed
  dyn_string devices, deviceDps;
  string modelName;
  string speed;
  string nodeName = fwFMC_getNodeName(hostDp);
  fwFMCMonitoring_getDevices(nodeName, "cpu", devices);

  for(int i = 1; i <= dynlen(devices); i++)
  {
    if(devices[i] == "-1")
      continue;

    dynAppend(deviceDps, hostDp + "/Monitoring/Cpus/" + devices[i]);
  }
  if(dynlen(devices) > 0 && devices[1] != -1)
  {
    dpGet(deviceDps[1] + ".info.model_name", modelName,
          deviceDps[1] + ".info.clock", speed);
  }
  string monitoringDp = hostDp + "/Monitoring";
  string name, distribution, lastBootUpTime, localDateTime, memory;
  dpGet(monitoringDp + ".OS.readings.name", name,
        monitoringDp + ".OS.readings.distribution", distribution,
        monitoringDp + "/Memory.readings.total", memory);

  int child = xmlAppendChild(docId, nodeId, XML_ELEMENT_NODE, "host");
  xmlSetElementAttribute(docId, child, "landbUrl", fwSystemOverview_LANDB_URL + nodeName);     
  fwSysOverviewXmlTree_addInfoNode(docId, child, "Operating System", name);   
  fwSysOverviewXmlTree_addInfoNode(docId, child, "Distribution", distribution);     
  fwSysOverviewXmlTree_addInfoNode(docId, child, "CPU", modelName);  
  fwSysOverviewXmlTree_addInfoNode(docId, child, "CPU Speed", speed + "MHz");  
  fwSysOverviewXmlTree_addInfoNode(docId, child, "Total Memory", memory + "kB");    
 
  string tmpStr;
  float memoryLoad, swap;
  dpGet(monitoringDp + "/Memory.readings.userMemory", memoryLoad,
        monitoringDp + "/Memory.readings.usedSwap", swap);
  sprintf(tmpStr, "%3.2f", memoryLoad);
  fwSysOverviewXmlTree_addInfoNode(docId, child, "Memory Load", tmpStr + "%");      
  sprintf(tmpStr, "%3.2f", swap);
  fwSysOverviewXmlTree_addInfoNode(docId, child, "Used Swap", tmpStr + "%");    
  float avgCpu = fwFMCMonitoring_getAverageCpuLoad(nodeName);  
  sprintf(tmpStr, "%3.2f", avgCpu);
  fwSysOverviewXmlTree_addInfoNode(docId, child, "Average CPU Load", tmpStr + "%");     
  dyn_string fileSystemDps;
  fwFMCMonitoring_getFSDps(nodeName, fileSystemDps);
  float usedFS;
  string fsMountPoint;
  for(int i=1; i <= dynlen(fileSystemDps); i++)
  {
    dpGet(fileSystemDps[i] + ".readings.mount_point", fsMountPoint,
          fileSystemDps[i] + ".readings.user", usedFS);
    sprintf(tmpStr, "%3.2f", usedFS);
    fwSysOverviewXmlTree_addInfoNode(docId, child, "Used FS " + fsMountPoint, tmpStr + "%");   
  }
  
  //add charts
  dyn_string charts = fwSysOverviewLongTermReport_getReportUrls(nodeName);
  for(int i=1; i<=dynlen(charts);i++)
  {
    fwSysOverviewXmlTree_addChartNode(docId, child, charts[i]);  
  }
  
  //add monitored processes information
  dyn_string ex;
  dyn_string processes = fwFMCProcess_getMonitoredProcesses(nodeName, ex);
  string options, name, description, color;
  int state;  
  for(int j=1; j<=dynlen(processes); j++)
  {
    dpGet(processes[j] + ".config.cmd", options,
          processes[j] + ".config.name", name,
          processes[j] + ".readings.state", state);
    description = name + " " + options;
    switch (state)
    {
      case -1:
        color = "cyan";
        break;
      case 1:
        color = "red";
        break;
      case 2:
        color = "green";
        break;
    };
    fwSysOverviewXmlTree_addDataNode(docId, child, description, color);
  }
   
}

void fwSysOverviewXmlTree_addPlcDetails(int docId, int nodeId, string plcDp)
{
 if (dpTypeName(plcDp) != "IcemonPlc")
  {
    DebugN("Not an IcemonPlc: " + plcDp);
    return;
  }
  string application, ip, plcTime;
  dyn_string metricValuesDps, metricAlarmsDps, metricAlarmActiveDps, validDps;
  dyn_int metricValues;
  dyn_bool metricAlarms, metricAlarmActive, valid;  
  dpGet(plcDp + ".Configuration.application", application,
        plcDp + ".Configuration.IP", ip,
        plcDp + ".ProcessInput.PLCtime", plcTime);
  string nodeName = dpGetAlias(plcDp + ".");
  int child = xmlAppendChild(docId, nodeId, XML_ELEMENT_NODE, "plc");
  xmlSetElementAttribute(docId, child, "landbUrl", fwSystemOverview_LANDB_URL_IP + ip);     
  fwSysOverviewXmlTree_addInfoNode(docId, child, "Manufacturer", application);
  fwSysOverviewXmlTree_addInfoNode(docId, child, "IP", ip);  
  fwSysOverviewXmlTree_addInfoNode(docId, child, "PLC Time", plcTime);    

  string prefix;
  int length;
  if (application =="SIEMENS")
  {
    prefix= "SI_"  ;
    length = PLC_SIEMENS_METRIC_LENGTH;
  }
  else if (application == "SCHNEIDER")
  {
    prefix = "SC_";
    length = PLC_SCHNEIDER_METRIC_LENGTH;
  }
  if (prefix != "")
  {
    for (int i=1; i<=length; i++)
    {
      dynAppend(metricValuesDps, plcDp + ".ProcessInput.metric[" + i+"]"); 
      dynAppend(validDps, plcDp + ".ProcessInput.valid"); 
      dynAppend(metricAlarmsDps, plcDp + ".ProcessInput.metric[" + i+"]:_alert_hdl.._act_state");      
      dynAppend(metricAlarmActiveDps, plcDp + ".ProcessInput.metric[" + i+"]:_alert_hdl.._active");          
     }
  }
  dpGet(validDps, valid, metricValuesDps, metricValues, metricAlarmsDps, metricAlarms, metricAlarmActiveDps, metricAlarmActive);
  for (int i=1; i<=dynlen(metricValues); i++)
  {
     string metricColor = "green";
     if(!valid[i])
       metricColor = "cyan";
     else if(!metricAlarmActive[i])// if the alarm is not active
       metricColor = "yellow";
     else if ((metricAlarms[i]!=0) && metricValues[i] == -1)
       metricColor = "cyan"; 
     else if ((metricAlarms[i]!=0))
       metricColor = "red";
  
     fwSysOverviewXmlTree_addDataNode(docId, child, getCatStr("plcMonitoring", getCatStr("plcMonitoring", prefix + i)), metricColor);
  }
  
}

void fwSysOverviewXmlTree_addFecDetails(int docId, int nodeId, string fecDp)
{
  if (dpTypeName(fecDp) != "IcemonFec")
  {
    DebugN("Not an IcemonFec: " + fecDp);
    return;
  }
  float freeMem, inactMem, swap, cpu;
  int uptime, misingProcessesCount;
  string listMissing;
  string cpuChartUrl, freeMemChartUrl, inactMemChartUrl;//, usedSwapChartUrl;
  bool valid;
  dpGet(fecDp + ".ProcessInput.readings.freeMemory.value", freeMem,
        fecDp + ".ProcessInput.readings.inactMemory.value", inactMem,
        fecDp + ".ProcessInput.readings.uptime.value", uptime,        
        fecDp + ".ProcessInput.readings.cpu.value", cpu,   
        fecDp + ".ProcessInput.processes.listMissing", listMissing,       
        fecDp + ".ProcessInput.processes.countMissing", misingProcessesCount,
        fecDp + ".ProcessInput.publicationsValid", valid,
        fecDp + ".TrendUrls.usedCpu", cpuChartUrl ,
        fecDp + ".TrendUrls.freeMemory", freeMemChartUrl,
        fecDp + ".TrendUrls.inactMemory", inactMemChartUrl);
  string nodeName = dpGetAlias(fecDp + ".");
  int child = xmlAppendChild(docId, nodeId, XML_ELEMENT_NODE, "fec");
  if (!valid)
  {
    fwSysOverviewXmlTree_addInfoNode(docId, child, "Validity", "Some of the publications are invalid!!");
  }
  xmlSetElementAttribute(docId, child, "landbUrl", fwSystemOverview_LANDB_URL + nodeName);     
  fwSysOverviewXmlTree_addInfoNode(docId, child, "Free memory", floor(freeMem) + "%");
  fwSysOverviewXmlTree_addInfoNode(docId, child, "Inactive memory", floor(inactMem) + "%");  
  fwSysOverviewXmlTree_addInfoNode(docId, child, "Used swap", floor(swap) + "%");  
  fwSysOverviewXmlTree_addInfoNode(docId, child, "Used CPU", floor(cpu) + "%");   
  fwSysOverviewXmlTree_addInfoNode(docId, child, "Started on", formatTime("%d/%m/%y %H:%M", getCurrentTime() - (time)uptime));  
  fwSysOverviewXmlTree_addInfoNode(docId, child, "Missing processes", misingProcessesCount==0?misingProcessesCount:misingProcessesCount+": " + listMissing);    
  fwSysOverviewXmlTree_addChartNode(docId, child, cpuChartUrl);
  fwSysOverviewXmlTree_addChartNode(docId, child, freeMemChartUrl);
  fwSysOverviewXmlTree_addChartNode(docId, child, inactMemChartUrl);
  //fwSysOverviewXmlTree_addChartNode(docId, child, usedSwapChartUrl);
      
}

void fwSysOverviewXmlTree_addSystemIntegrityDetails(int docId, int nodeId, string siDp)
{  
 if (dpTypeName(siDp) != "IcemonSystemIntegrity")
  {
    DebugN("Not IcemonSystemIntegrity: " + siDp);
    return;
  }
  // get the systemName
  int child = xmlAppendChild(docId, nodeId, XML_ELEMENT_NODE, "systemIntegrity");  
  string systemName;
  bool connected = false;
  dpGet(siDp + ".systemName", systemName,
        siDp + ".connected", connected);
  fwSysOverviewXmlTree_addInfoNode(docId, child, "System Name", systemName);
  if (connected) 
  {
    dyn_dyn_string siAlarmDescriptionsAndColors = fwSysOverviewXmlTree_getSystemIntegrityApplicationAlarmsAndColors(siDp);
 
    for (int i=1; i<=dynlen(siAlarmDescriptionsAndColors); i++)
    {
       string description = siAlarmDescriptionsAndColors[i][1];
       strreplace(description, "->", "");
       string siColor = siAlarmDescriptionsAndColors[i][2];
       string color = siColor;
       if (mappingHasKey(fwColorToColor, siColor))
         color = fwColorToColor[color];      
   
        fwSysOverviewXmlTree_addDataNode(docId, child, description, color);    
    }
  }
  else
     fwSysOverviewXmlTree_addInfoNode(docId, child, "Connection", "System not connected!");
}

void fwSysOverviewXmlTree_addDipMonitoringDetails(int docId, int nodeId, string dipPublicationDp, string alarmDp = "")
{
  if (alarmDp == "")
  {
    alarmDp = c_unSystemAlarm_dpPattern+DPE_pattern + dpSubStr(dipPublicationDp, DPSUB_DP) + ".alarm";
  }
  if (!dpExists(alarmDp))
  {
    DebugN("fwSysOverviewXmlTree_addDipMonitoringDetails: Dp doesn't exist: " + alarmDp);
    return;
  }
  string timestampDp  = dipPublicationDp + ":_original.._stime";
  string alarmStateDp = alarmDp + ":_alert_hdl.._act_state";    
  string alarmActiveDp = alarmDp + ":_alert_hdl.._active";        
  
  int val;
  time timestamp;
  bool alarmActive, alarmState;
  dpGet(dipPublicationDp, val,
        timestampDp, timestamp,
        alarmActiveDp, alarmActive,
        alarmStateDp, alarmState);

  string color;
  if (!alarmActive)
    color = "yellow";
  else if(alarmState)
    color = "red";
  else
    color = "green";
  int child = xmlAppendChild(docId, nodeId, XML_ELEMENT_NODE, "dipPublication"); 
  fwSysOverviewXmlTree_addInfoNode(docId, child, "Publication", dpSubStr(dipPublicationDp, DPSUB_DP));
  fwSysOverviewXmlTree_addInfoNode(docId, child, "Value", val); 
  fwSysOverviewXmlTree_addDataNode(docId, child, "Last update: " + formatTime("%d/%m/%y %H:%M:%S", timestamp), color); 
}

void fwSysOverviewXmlTree_addDipDnsMonitoringDetails(int docId, int nodeId, string dipDnsDp)
{
  bool runningOnSecondary, runningOnBoth, notRunning;
  string runningOnSecondaryText, runningOnBothText, notRunningText;

  dpGet(dipDnsDp + ".runningOnSecondaryDNS:_alert_hdl.._act_state", runningOnSecondary,
        dipDnsDp + ".runningOnSecondaryDNS:_alert_hdl.._act_text", runningOnSecondaryText,
        dipDnsDp + ".runningOnBoth:_alert_hdl.._act_state", runningOnBoth,
        dipDnsDp + ".runningOnBoth:_alert_hdl.._act_text", runningOnBothText,        
        dipDnsDp + ".notRunning:_alert_hdl.._act_state", notRunning,
        dipDnsDp + ".notRunning:_alert_hdl.._act_text", notRunningText);

  string state, color;  
  int primaryManState, secodnaryManState;
  fwSysOverview_getManagerState("moon_300:SystemOverview/CS-CCR-MOON/MOON", "dip", "-dns cs-ccr-diptn1", primaryManState);
  fwSysOverview_getManagerState("moon_300:SystemOverview/CS-CCR-MOON/MOON", "dip", "-dns cs-ccr-diptn2", secodnaryManState);
  if (primaryManState != fwSysOverview_RUNNING && secodnaryManState != fwSysOverview_RUNNING && secodnaryManState != fwSysOverview_BLOCKED)
  {
    state = "The state of the DNS is unknown.";
    color = "yellow";
  }
  else if(runningOnSecondary) 
  {
    state = runningOnSecondaryText;
    color = "red";    
  }
  else if (runningOnBoth)
  {
    state = runningOnBothText;
    color = "red";      
  }
  else if (notRunning)
  {
    state = notRunningText;
    color = "red";      
  }
  else 
  {
    state = "The primary DNS is running correctly";
    color = "green";
  }
  int child = xmlAppendChild(docId, nodeId, XML_ELEMENT_NODE, "dipPublication"); 
  fwSysOverviewXmlTree_addDataNode(docId, child, state, color); 
}


void fwSysOverviewXmlTree_addLicenseGeneratorDetails(int docId, int nodeId, string licenseGeneratorDp)
{
  bool holdFilePresent, holdFilePresentAlarm, lastCronRunAlarm, lastCompletedAlarm, dongleUnknownAlarm, licensesLeftAlarm;
  int licenseLeft, secondsSinceLastCompleted, secondsSinceLastCronRun;
  string dongleContent;
  dpGet(licenseGeneratorDp + ".holdFilePresent", holdFilePresent,
        licenseGeneratorDp + ".holdFilePresent:_alert_hdl.._act_state", holdFilePresentAlarm,
        licenseGeneratorDp + ".lastCronRunSecondsSinceModification", secondsSinceLastCronRun,
        licenseGeneratorDp + ".lastCronRunSecondsSinceModification:_alert_hdl.._act_state", lastCronRunAlarm,
        licenseGeneratorDp + ".lastCompletedSecondsSinceModification", secondsSinceLastCronRun,
        licenseGeneratorDp + ".lastCompletedSecondsSinceModification:_alert_hdl.._act_state", lastCompletedAlarm,
        licenseGeneratorDp + ".whichDongleContent", dongleContent, 
        licenseGeneratorDp + ".whichDongleContentUnknown:_alert_hdl.._act_state", dongleUnknownAlarm,
        licenseGeneratorDp + ".licensesLeftContent", licenseLeft, 
        licenseGeneratorDp + ".licensesLeftContent:_alert_hdl.._act_state", licensesLeftAlarm);
  int child = xmlAppendChild(docId, nodeId, XML_ELEMENT_NODE, "device"); 
  fwSysOverviewXmlTree_addDataNode(docId, child, "Hold file present", holdFilePresentAlarm?"red":"green"); 
  fwSysOverviewXmlTree_addDataNode(docId, child, "Seconds since last cron run", lastCronRunAlarm?"red":"green"); 
  fwSysOverviewXmlTree_addDataNode(docId, child, "Seconds since last completed", lastCompletedAlarm?"red":"green"); 
  fwSysOverviewXmlTree_addDataNode(docId, child, "WhichDongle content", dongleUnknownAlarm?"red":"green"); 
  fwSysOverviewXmlTree_addDataNode(docId, child, "LicensesLeft content", licensesLeftAlarm?"red":"green");   
  
}

dyn_dyn_string fwSysOverviewXmlTree_getSystemIntegrityApplicationAlarmsAndColors(string siDp)
{
  dyn_dyn_string siAlarmDescriptionsAndColors;
  // if the summary alert is not active we return the stored list and green as a color;
  bool alarm, connected;
  dyn_string alarmsDescriptions;
  dyn_string applicationAlarms;
  dyn_bool masked;
  dyn_bool hidden;
  dyn_int status;
  dyn_int values;
  
  dpGet(siDp + ".alarm", alarm,
        siDp + ".connected", connected,
        siDp + ".applicationAlarmsList.dpes", applicationAlarms,
        siDp + ".applicationAlarmsList.descriptions", alarmsDescriptions,
        siDp + ".applicationAlarmsList.locallyMasked", masked,
        siDp + ".applicationAlarmsList.locallyHidden", hidden,
        siDp + ".applicationAlarmsList.alarmStatus", status,
        siDp + ".applicationAlarmsList.values", values
        );
  bool bHidden = false;
  bool bMasked = false;
  
  string color = connected?"green":"purple";
  if (!alarm || !connected)
  {
    for(int i=1; i<=dynlen(alarmsDescriptions);i++)
    {
      siAlarmDescriptionsAndColors[i][1] = alarmsDescriptions[i] + " - Current Value: " + values[i];
      if(dynlen(masked) >= i)
      {
        bMasked = masked[i];
      }
      else
      {
        bMasked = false;      
      }
      
      if(dynlen(hidden) >= i)
      {
        bHidden = hidden[i];
      }
      else
      {
        bHidden = false;      
      }
      
      if(bHidden)
      {
        color = "purple";
      }
      else if(bMasked)
      {
        color = "yellow";            
      }
      else
      {
        color = "green";
      }
 
      siAlarmDescriptionsAndColors[i][2] = color;
    }
  }
  else
  {
    for(int i=1; i<=dynlen(applicationAlarms);i++)
    {
      string description = alarmsDescriptions[i];
      if (description == "")
        description = applicationAlarms[i];
      bool alarmPresent;
      int value = -1;
      string color = status[i]? "red":"green";
      siAlarmDescriptionsAndColors[i][1] = description + "- Curren Value: " + values[i];
      
      if(dynlen(masked) >= i)
      {
        bMasked = masked[i];
      }
      else
      {
        bMasked = false;      
      }
      if(dynlen(hidden) >= i)
      {
        bHidden = hidden[i];
      }
      else
      {
        bHidden = false;      
      }
      
      if(bHidden)
      {
        color = "purple";
      }
      else if(bMasked)
      {
        color = "yellow";            
      }
      
      siAlarmDescriptionsAndColors[i][2] = color;
      
    }
  }
   return siAlarmDescriptionsAndColors;
}

int fwSysOverviewXmlTree_addInfoNode(int docId, int nodeId, string description, string value)
{
  int infoNode = xmlAppendChild(docId, nodeId, XML_ELEMENT_NODE, "info");
  xmlSetElementAttribute(docId, infoNode, "description", description);     
  xmlSetElementAttribute(docId, infoNode, "value", value);  
  return  infoNode; 
}
int fwSysOverviewXmlTree_addDataNode(int docId, int nodeId, string description, string color)
{
  int dataNode = xmlAppendChild(docId, nodeId, XML_ELEMENT_NODE, "data");
  xmlSetElementAttribute(docId, dataNode, "description", description);     
  xmlSetElementAttribute(docId, dataNode, "color", color);  
  return  dataNode; 
}
int fwSysOverviewXmlTree_addChartNode(int docId, int nodeId, string chartUrl)
{
  int dataNode = xmlAppendChild(docId, nodeId, XML_ELEMENT_NODE, "chart");
  strreplace(chartUrl, "&amp;", "&");
  xmlSetElementAttribute(docId, dataNode, "url", chartUrl);     
  return  dataNode; 
}

void fwSysOverviewXmlTree_createTreesHtmlFrame(string filePath = "")
{
  dyn_string soTrees;
  fwSystemOverviewFsm_getTrees(soTrees);  
  
  string html;
  if (dynlen(soTrees) > 0)
  {
    html = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">" +
             "<html xmlns=\"http://www.w3.org/1999/xhtml\">"+
             "<head>" +
             "<meta content=\"text/html; charset=iso-8859-1\" http-equiv=\"Content-Type\" />"+
             "<title>MOON</title>" +
             "<link href=\"styles/styles.css\" rel=\"stylesheet\" type=\"text/css\" />"+
             "<style type=\"text/css\">"+
             "html, body, iframe { margin:0; padding:0; height:100%; width:100%}"+
             "iframe { display:block; width:100%; border:none; }"+
             "</style>"+
             "<script type=\"text/javascript\" src=\"scripts/scripts.js\"></script>"+
             "</head>"+
             "<body onload=\"load('" + soTrees[1] + "')\">"+
             "<table style=\"height: 95%;width:100%\">" +
             "<tr>" +
        		 "<td style=\"padding-bottom:0px\">"+
  		       "<ul class=\"tabs\">";
 
  
    for(int i = 1; i<= dynlen(soTrees); i++)
    {
      string label;
      fwUi_getLabel(soTrees[i], soTrees[i], label);
      html += "<li id=\"" + soTrees[i] + "\"><a href=\"tree/" + soTrees[i] + ".xml\" target=\"fsmTreeFrame\" onclick=\"changeSelection('" + soTrees[i] + "')\">" +label+ "</a></li>";

    }
    html += "</ul>";
    html += "</td>";    
    html += "<td class=\"t2navbarcell\" >";
    html += "<a href=\"rss/moonRssFrontPage.html\" class=\"t2navbar\"><img src=\"styles/feed.gif\" alt=\"News Feed\" height=\"16\" width=\"16\" />News Feed</a>";
  	html+= "</td>";
    html += " <td class=\"t2navbarcell\" ><a href=\"projectsOverview/index.html\" class=\"t2navbar\"><img src=\"styles/reports.png\" alt=\"Reports\" height=\"16\" width=\"16\" />Reports</a></td>";
    html += "<td class=\"t2navbarcell\" >";
    html += "<a href=\"statistics/overallStatistics.html\" class=\"t2navbar\"><img src=\"styles/stats1.jpg\" alt=\"Statistics\" height=\"16\" width=\"16\" />Statistics</a>";
  	html+= "</td>";
  	html +="</tr>";
  	html +="<tr valign=\"top\">";
  	html +="<td style=\"width: 90%; height: 100%;\" colspan=\"3\">";
  	html +="<iframe id=\"fsmTreeFrame\" frameborder=\"0\" name=\"fsmTreeFrame\" scrolling=\"auto\" src=\"tree/"+soTrees[1]+".xml\" style=\"overflow:visible\" >";
  	html +="</iframe></td>";
    html +="</tr>";
    html +="</table>";
    html +="</body>";
    html +="</html>";
    string destinationFolder = filePath==""?_fwSysOverviewLongTermReport_getFilePath():filePath;
    string filePath =  destinationFolder  + "/index.html";
    file f = fopen(filePath, "w+");
    int err = ferror(f);
    if (!err)
    {
      fputs(html, f);
      fclose(f);
    }
  }
}

